/*******************************************************************************
 * FoxBillboardUIContainer generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxBillboardUIContainer extends GFxObject within GFxMoviePlayer
    native(HUD);

var int BillboardCounter;
var array<FoxBillboardUIObjectBase> Billboards;
var array<FoxBillboardUIDamageIndicator> DamageIndicators;
var transient FoxPC PCOwner;
var transient bool bBillboardsHidden;

event FoxBillboardUIObjectBase SpawnBillboard(class<FoxBillboardUIObjectBase> BillboardClass)
{
    local FoxBillboardUIObjectBase NewBillboard;
    local string instancename;

    instancename = "BillboardObject_" $ string(BillboardCounter);
    NewBillboard = FoxBillboardUIObjectBase(AttachMovieClip(BillboardClass.default.symbolname, instancename, BillboardClass));
    NewBillboard.instancename = instancename;
    NewBillboard.PCOwner = PCOwner;
    ++ BillboardCounter;
    // End:0x10B
    if(FoxBillboardUIDamageIndicator(NewBillboard) != none)
    {
        DamageIndicators.AddItem(FoxBillboardUIDamageIndicator(NewBillboard));
    }
    // End:0x141
    else
    {
        Billboards.AddItem(NewBillboard);
        NewBillboard.SetVisible(false);
    }
    // End:0x16F
    if(NewBillboard != none)
    {
        NewBillboard.Initialize();
    }
    return NewBillboard;
    //return ReturnValue;    
}

function HideAllBillboards()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x5B [Loop If]
    if(I < Billboards.Length)
    {
        Billboards[I].SetVisible(false);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    bBillboardsHidden = true;
    //return;    
}

function ShowBillboards()
{
    bBillboardsHidden = false;
    //return;    
}

function RemoveAllBillboards()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x5A [Loop If]
    if(I < Billboards.Length)
    {
        Billboards[I].RemoveMovieClip();
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    Billboards.Length = 0;
    //return;    
}

event RemoveBillboard(FoxBillboardUIObjectBase Billboard)
{
    local int BillboardIndex;

    BillboardIndex = Billboards.Find(Billboard);
    // End:0x67
    if(BillboardIndex != -1)
    {
        Billboard.RemoveMovieClip();
        Billboards.Remove(BillboardIndex, 1);
    }
    //return;    
}

function RemoveBillboardByName(string instancename)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xAB [Loop If]
    if(I >= 0)
    {
        // End:0x9D
        if(Billboards[I].instancename == instancename)
        {
            Billboards[I].RemoveMovieClip();
            Billboards.Remove(I, 1);
            // [Explicit Break]
            goto J0xAB;
        }
        -- I;
        J0xAB:
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function NotifyTeamChange()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x5A [Loop If]
    if(I < Billboards.Length)
    {
        Billboards[I].NotifyTeamChange();
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function SpawnWeaponDepotBillboard(FoxGameObject_WeaponDepot Depot)
{
    local FoxBillboardUIDepot NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIDepot(Billboards[I]) != none) && FoxBillboardUIDepot(Billboards[I]).Depot == Depot)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIDepot(SpawnBillboard(class'FoxBillboardUIDepot'));
    // End:0xF3
    if(NewBillboard != none)
    {
        NewBillboard.Depot = Depot;
    }
    //return;    
}

function SpawnControlPointBillboard(FoxGameObject_ControlPoint ControlPoint)
{
    local FoxBillboardUIControlPoint NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIControlPoint(Billboards[I]) != none) && FoxBillboardUIControlPoint(Billboards[I]).ControlPoint == ControlPoint)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIControlPoint(SpawnBillboard(class'FoxBillboardUIControlPoint'));
    // End:0xF3
    if(NewBillboard != none)
    {
        NewBillboard.ControlPoint = ControlPoint;
    }
    //return;    
}

function SpawnFlagBillboard(FoxGameObject_Flag FlagObject)
{
    local FoxBillboardUIFlag NewFlagBillboard;
    local FoxBillboardUIFlagBase NewFlagBaseBillboard;
    local class<FoxBillboardUIFlag> BillboardClass;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIFlag(Billboards[I]) != none) && FoxBillboardUIFlag(Billboards[I]).FlagObject == FlagObject)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    // End:0xC4
    if(FoxGameObject_EOTSFlag(FlagObject) != none)
    {
        BillboardClass = class'FoxBillboardUIEOTSFLag';
    }
    // End:0xD7
    else
    {
        BillboardClass = class'FoxBillboardUIFlag';
    }
    NewFlagBillboard = FoxBillboardUIFlag(SpawnBillboard(BillboardClass));
    // End:0x134
    if(NewFlagBillboard != none)
    {
        NewFlagBillboard.FlagObject = FlagObject;
    }
    NewFlagBillboard.SetBool("showFlag", NewFlagBillboard.bShowFlagIcon);
    I = 0;
    J0x187:
    // End:0x262 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x254
        if((FoxBillboardUIFlagBase(Billboards[I]) != none) && FoxBillboardUIFlagBase(Billboards[I]).FlagLocation == FlagObject.Location)
        {
            FoxBillboardUIFlagBase(Billboards[I]).FlagObject = FlagObject;
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x187;
    }
    // End:0x2D7
    if(FoxGameObject_EOTSFlag(FlagObject) == none)
    {
        NewFlagBaseBillboard = FoxBillboardUIFlagBase(SpawnBillboard(class'FoxBillboardUIFlagBase'));
        // End:0x2D7
        if(NewFlagBaseBillboard != none)
        {
            NewFlagBaseBillboard.FlagObject = FlagObject;
        }
    }
    //return;    
}

function RemoveFlagBillboard(FoxGameObject_Flag FlagObject)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0x180 [Loop If]
    if(I >= 0)
    {
        // End:0xDC
        if((FoxBillboardUIFlag(Billboards[I]) != none) && FoxBillboardUIFlag(Billboards[I]).FlagObject == FlagObject)
        {
            FoxBillboardUIFlag(Billboards[I]).FlagObject = none;
            RemoveBillboard(Billboards[I]);
        }
        // End:0x172
        else
        {
            // End:0x172
            if((FoxBillboardUIFlagBase(Billboards[I]) != none) && FoxBillboardUIFlagBase(Billboards[I]).FlagObject == FlagObject)
            {
                FoxBillboardUIFlagBase(Billboards[I]).FlagObject = none;
            }
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnTKOTHBillboard(FoxGameObject_HillPoint HillPoint)
{
    local FoxBillboardUIHillPoint NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIHillPoint(Billboards[I]) != none) && FoxBillboardUIHillPoint(Billboards[I]).HillPoint == HillPoint)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIHillPoint(SpawnBillboard(class'FoxBillboardUIHillPoint'));
    // End:0x133
    if(NewBillboard != none)
    {
        NewBillboard.HillPoint = HillPoint;
        NewBillboard.as_SetShowProgressNumbers(false);
        NewBillboard.as_SetShowProgressBars(false);
    }
    //return;    
}

function RemoveTKOTHBillboard(FoxGameObject_HillPoint HillPoint)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIHillPoint(Billboards[I]) != none) && FoxBillboardUIHillPoint(Billboards[I]).HillPoint == HillPoint)
        {
            FoxBillboardUIHillPoint(Billboards[I]).HillPoint = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnOSPointBillboard(FoxGameObject_OSPoint OSPoint)
{
    local FoxBillboardUIOSPoint NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIOSPoint(Billboards[I]) != none) && FoxBillboardUIOSPoint(Billboards[I]).OSPoint == OSPoint)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIOSPoint(SpawnBillboard(class'FoxBillboardUIOSPoint'));
    // End:0xF3
    if(NewBillboard != none)
    {
        NewBillboard.OSPoint = OSPoint;
    }
    //return;    
}

function RemoveOSPointBillboard(FoxGameObject_OSPoint OSPoint)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIOSPoint(Billboards[I]) != none) && FoxBillboardUIOSPoint(Billboards[I]).OSPoint == OSPoint)
        {
            FoxBillboardUIOSPoint(Billboards[I]).OSPoint = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnPlayerNameBillboard(FoxPawn Pawn)
{
    local FoxBillboardPlayerName NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0xD4 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xC6
        if(((FoxBillboardPlayerName(Billboards[I]) != none) && FoxBillboardPlayerName(Billboards[I]).BillboardType == 0) && FoxBillboardPlayerName(Billboards[I]).Pawn == Pawn)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardPlayerName(SpawnBillboard(class'FoxBillboardPlayerName'));
    // End:0x236
    if(NewBillboard != none)
    {
        NewBillboard.BillboardType = 0;
        NewBillboard.Pawn = Pawn;
        // End:0x1D8
        if(Pawn.bIsMachine == true)
        {
            NewBillboard.bShowHealth = PCOwner.GetLoadoutInfo().HasTacticalClass('RepairGunGear');
        }
        // End:0x236
        else
        {
            NewBillboard.bShowHealth = PCOwner.GetLoadoutInfo().HasTacticalClass('HealGunGear');
        }
    }
    //return;    
}

function RemovePlayerNameBillboard(FoxPawn Pawn)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0x125 [Loop If]
    if(I >= 0)
    {
        // End:0x117
        if(((FoxBillboardPlayerName(Billboards[I]) != none) && FoxBillboardPlayerName(Billboards[I]).BillboardType == 0) && FoxBillboardPlayerName(Billboards[I]).Pawn == Pawn)
        {
            FoxBillboardPlayerName(Billboards[I]).Pawn = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnDecoyNameBillboard(FoxProjectile_DecoyBase Decoy)
{
    local FoxBillboardPlayerName NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardPlayerName(Billboards[I]) != none) && FoxBillboardPlayerName(Billboards[I]).Decoy == Decoy)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardPlayerName(SpawnBillboard(class'FoxBillboardPlayerName'));
    // End:0x133
    if(NewBillboard != none)
    {
        NewBillboard.BillboardType = 1;
        NewBillboard.Decoy = Decoy;
        NewBillboard.PostInitialize();
    }
    //return;    
}

function RemoveDecoyNameBillboard(FoxProjectile_DecoyBase Decoy)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardPlayerName(Billboards[I]) != none) && FoxBillboardPlayerName(Billboards[I]).Decoy == Decoy)
        {
            FoxBillboardPlayerName(Billboards[I]).Decoy = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnHeroPoseNameBillboard(FoxHeroPoseActor HeroPoseActor)
{
    local FoxBillboardUIHeroPoseName NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIHeroPoseName(Billboards[I]) != none) && FoxBillboardUIHeroPoseName(Billboards[I]).HeroPoseActor == HeroPoseActor)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIHeroPoseName(SpawnBillboard(class'FoxBillboardUIHeroPoseName'));
    // End:0x197
    if(NewBillboard != none)
    {
        NewBillboard.HeroPoseActor = HeroPoseActor;
        NewBillboard.as_SetPlayerName(HeroPoseActor.PRI.PlayerName);
        NewBillboard.as_SetClanTag(HeroPoseActor.PRI.ClanTag);
    }
    //return;    
}

function SpawnPlayerMarkerBillboard(FoxPawn Pawn)
{
    local FoxBillboardUIHRVPlayerMarker NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0xD4 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xC6
        if(((FoxBillboardUIHRVPlayerMarker(Billboards[I]) != none) && FoxBillboardUIHRVPlayerMarker(Billboards[I]).BillboardType == 0) && FoxBillboardUIHRVPlayerMarker(Billboards[I]).Pawn == Pawn)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIHRVPlayerMarker(SpawnBillboard(class'FoxBillboardUIHRVPlayerMarker'));
    // End:0x152
    if(NewBillboard != none)
    {
        NewBillboard.BillboardType = 0;
        NewBillboard.Pawn = Pawn;
    }
    //return;    
}

function RemovePlayerMarkerBillboard(FoxPawn Pawn)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0x125 [Loop If]
    if(I >= 0)
    {
        // End:0x117
        if(((FoxBillboardUIHRVPlayerMarker(Billboards[I]) != none) && FoxBillboardUIHRVPlayerMarker(Billboards[I]).BillboardType == 0) && FoxBillboardUIHRVPlayerMarker(Billboards[I]).Pawn == Pawn)
        {
            FoxBillboardUIHRVPlayerMarker(Billboards[I]).Pawn = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnDecoyMarkerBillboard(FoxProjectile_DecoyBase Decoy)
{
    local FoxBillboardUIHRVPlayerMarker NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIHRVPlayerMarker(Billboards[I]) != none) && FoxBillboardUIHRVPlayerMarker(Billboards[I]).Decoy == Decoy)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIHRVPlayerMarker(SpawnBillboard(class'FoxBillboardUIHRVPlayerMarker'));
    // End:0x114
    if(NewBillboard != none)
    {
        NewBillboard.BillboardType = 1;
        NewBillboard.Decoy = Decoy;
    }
    //return;    
}

function RemoveDecoyMarkerBillboard(FoxProjectile_DecoyBase Decoy)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIHRVPlayerMarker(Billboards[I]) != none) && FoxBillboardUIHRVPlayerMarker(Billboards[I]).Decoy == Decoy)
        {
            FoxBillboardUIHRVPlayerMarker(Billboards[I]).Decoy = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnMineBillboard(FoxProjectile_MineBase Mine)
{
    local FoxBillboardUIMine NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIMine(Billboards[I]) != none) && FoxBillboardUIMine(Billboards[I]).Mine == Mine)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIMine(SpawnBillboard(class'FoxBillboardUIMine'));
    // End:0xF3
    if(NewBillboard != none)
    {
        NewBillboard.Mine = Mine;
    }
    //return;    
}

function RemoveMineBillboard(FoxProjectile_MineBase Mine)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIMine(Billboards[I]) != none) && FoxBillboardUIMine(Billboards[I]).Mine == Mine)
        {
            FoxBillboardUIMine(Billboards[I]).Mine = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnHealTargetBillboard(FoxPawn Target)
{
    local FoxBillboardUIHealTarget NewBillboard;
    local int I;

    // End:0x5A
    if(!PCOwner.GetLoadoutInfo().HasTacticalClass(class'FoxBillboardUIHealTarget'.default.TacticalSpecificClassName))
    {
        return;
    }
    // End:0x81
    if(Target.bIsMachine == true)
    {
        return;
    }
    I = 0;
    J0x8C:
    // End:0x117 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x109
        if((FoxBillboardUIHealTarget(Billboards[I]) != none) && FoxBillboardUIHealTarget(Billboards[I]).PawnTarget == Target)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x8C;
    }
    NewBillboard = FoxBillboardUIHealTarget(SpawnBillboard(class'FoxBillboardUIHealTarget'));
    // End:0x174
    if(NewBillboard != none)
    {
        NewBillboard.PawnTarget = Target;
    }
    //return;    
}

function RemoveHealTargetBillboard(FoxPawn Target)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIHealTarget(Billboards[I]) != none) && FoxBillboardUIHealTarget(Billboards[I]).PawnTarget == Target)
        {
            FoxBillboardUIHealTarget(Billboards[I]).PawnTarget = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnRepairTargetBillboard(FoxPawn Target)
{
    local FoxBillboardUIRepairTarget NewBillboard;
    local int I;

    // End:0x5A
    if(!PCOwner.GetLoadoutInfo().HasTacticalClass(class'FoxBillboardUIRepairTarget'.default.TacticalSpecificClassName))
    {
        return;
    }
    // End:0x81
    if(Target.bIsMachine == false)
    {
        return;
    }
    I = 0;
    J0x8C:
    // End:0x117 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x109
        if((FoxBillboardUIRepairTarget(Billboards[I]) != none) && FoxBillboardUIRepairTarget(Billboards[I]).PawnTarget == Target)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x8C;
    }
    NewBillboard = FoxBillboardUIRepairTarget(SpawnBillboard(class'FoxBillboardUIRepairTarget'));
    // End:0x174
    if(NewBillboard != none)
    {
        NewBillboard.PawnTarget = Target;
    }
    //return;    
}

function RemoveRepairTargetBillboard(FoxPawn Target)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIRepairTarget(Billboards[I]) != none) && FoxBillboardUIRepairTarget(Billboards[I]).PawnTarget == Target)
        {
            FoxBillboardUIRepairTarget(Billboards[I]).PawnTarget = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

event SpawnDamageIndicator(Vector2D HitLocation, bool bFallDamage)
{
    local FoxBillboardUIDamageIndicator NewDamageIndicator;
    local int I;
    local ASDisplayInfo NewDisplayInfo;

    // End:0x173
    if(bFallDamage)
    {
        I = 0;
        J0x18:
        // End:0x80 [Loop If]
        if(I < DamageIndicators.Length)
        {
            // End:0x72
            if(FoxBillboardUIFallDamageIndicator(DamageIndicators[I]) != none)
            {
                NewDamageIndicator = DamageIndicators[I];
                // [Explicit Break]
                goto J0x80;
            }
            ++ I;
            J0x80:
            // [Loop Continue]
            goto J0x18;
        }
        // End:0xB5
        if(NewDamageIndicator == none)
        {
            NewDamageIndicator = FoxBillboardUIDamageIndicator(SpawnBillboard(class'FoxBillboardUIFallDamageIndicator'));
        }
        NewDamageIndicator.SetPosition(0.0, 130.0);
        NewDisplayInfo = NewDamageIndicator.GetDisplayInfo();
        NewDisplayInfo.hasAlpha = true;
        NewDisplayInfo.Alpha = 100.0;
        NewDamageIndicator.SetDisplayInfo(NewDisplayInfo);
    }
    // End:0x199
    else
    {
        NewDamageIndicator = FoxBillboardUIDamageIndicator(SpawnBillboard(class'FoxBillboardUIDamageIndicator'));
    }
    // End:0x1F4
    if(NewDamageIndicator != none)
    {
        NewDamageIndicator.ElapsedTime = 0.0;
        NewDamageIndicator.DamageLocation = HitLocation;
    }
    NewDamageIndicator.UpdateRotationAndOpacity();
    //return;    
}

event RemoveDamageIndicator(FoxBillboardUIDamageIndicator IndicatorToRemove)
{
    IndicatorToRemove.RemoveMovieClip();
    DamageIndicators.RemoveItem(IndicatorToRemove);
    //return;    
}

function RemoveAllDamageIndicators()
{
    local int I;

    I = DamageIndicators.Length - 1;
    J0x17:
    // End:0x51 [Loop If]
    if(I >= 0)
    {
        RemoveDamageIndicator(DamageIndicators[I]);
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnObjectiveBillboard(FoxObjectiveMarker MarkerObject)
{
    local FoxBillboardUIObjective NewObjectiveBillboard;
    local int I;

    // End:0x37
    if((MarkerObject == none) || !MarkerObject.bActive)
    {
        return;
    }
    I = 0;
    J0x42:
    // End:0xCD [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xBF
        if((FoxBillboardUIObjective(Billboards[I]) != none) && FoxBillboardUIObjective(Billboards[I]).MarkerObject == MarkerObject)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x42;
    }
    NewObjectiveBillboard = FoxBillboardUIObjective(SpawnBillboard(class'FoxBillboardUIObjective'));
    // End:0x12A
    if(NewObjectiveBillboard != none)
    {
        NewObjectiveBillboard.MarkerObject = MarkerObject;
    }
    //return;    
}

function SpawnDeployableBillboard(FoxDeployable_Base Deployable)
{
    local FoxBillboardDeployable NewBillboard;
    local int I;

    // End:0x74
    if(!PCOwner.GetLoadoutInfo().HasTacticalClass(class'FoxBillboardDeployable'.default.TacticalSpecificClassName) && FoxDeployable_JammerBase(Deployable) == none)
    {
        return;
    }
    I = 0;
    J0x7F:
    // End:0x10A [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xFC
        if((FoxBillboardDeployable(Billboards[I]) != none) && FoxBillboardDeployable(Billboards[I]).Deployable == Deployable)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x7F;
    }
    // End:0x1BE
    if(FoxDeployable_JammerBase(Deployable) != none)
    {
        NewBillboard = FoxBillboardDeployable(SpawnBillboard(class'FoxBillboardUIJammer'));
        NewBillboard.bShowHealth = PCOwner.GetLoadoutInfo().HasTacticalClass(class'FoxBillboardDeployable'.default.TacticalSpecificClassName);
    }
    // End:0x1E4
    else
    {
        NewBillboard = FoxBillboardDeployable(SpawnBillboard(class'FoxBillboardDeployable'));
    }
    // End:0x21B
    if(NewBillboard != none)
    {
        NewBillboard.Deployable = Deployable;
    }
    //return;    
}

function RemoveDeployableBillboard(FoxDeployable_Base Deployable)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardDeployable(Billboards[I]) != none) && FoxBillboardDeployable(Billboards[I]).Deployable == Deployable)
        {
            FoxBillboardDeployable(Billboards[I]).Deployable = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnDeployableTargetBillboard(FoxDeployable_Base Deployable)
{
    local FoxBillboardUIRepairTargetDeployable NewBillboard;
    local int I;

    // End:0x5A
    if(!PCOwner.GetLoadoutInfo().HasTacticalClass(class'FoxBillboardDeployable'.default.TacticalSpecificClassName))
    {
        return;
    }
    I = 0;
    J0x65:
    // End:0xF0 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xE2
        if((FoxBillboardUIRepairTargetDeployable(Billboards[I]) != none) && FoxBillboardUIRepairTargetDeployable(Billboards[I]).Deployable == Deployable)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x65;
    }
    NewBillboard = FoxBillboardUIRepairTargetDeployable(SpawnBillboard(class'FoxBillboardUIRepairTargetDeployable'));
    // End:0x14D
    if(NewBillboard != none)
    {
        NewBillboard.Deployable = Deployable;
    }
    //return;    
}

function RemoveDeployableTargetBillboard(FoxDeployable_Base Deployable)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIRepairTargetDeployable(Billboards[I]) != none) && FoxBillboardUIRepairTargetDeployable(Billboards[I]).Deployable == Deployable)
        {
            FoxBillboardUIRepairTargetDeployable(Billboards[I]).Deployable = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function RemoveObjectiveBillboard(FoxObjectiveMarker MarkerObject)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xE4 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xD6
        if((FoxBillboardUIObjective(Billboards[I]) != none) && FoxBillboardUIObjective(Billboards[I]).MarkerObject == MarkerObject)
        {
            FoxBillboardUIObjective(Billboards[I]).MarkerObject = none;
            RemoveBillboard(Billboards[I]);
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function SpawnTeamObjectiveBillboard(FoxTeamObjectiveMarker MarkerObject)
{
    local FoxBillboardUITeamObjective NewObjectiveBillboard;
    local int I;

    // End:0x37
    if((MarkerObject == none) || !MarkerObject.bActive)
    {
        return;
    }
    I = 0;
    J0x42:
    // End:0xCD [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xBF
        if((FoxBillboardUITeamObjective(Billboards[I]) != none) && FoxBillboardUITeamObjective(Billboards[I]).MarkerObject == MarkerObject)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x42;
    }
    NewObjectiveBillboard = FoxBillboardUITeamObjective(SpawnBillboard(class'FoxBillboardUITeamObjective'));
    // End:0x12A
    if(NewObjectiveBillboard != none)
    {
        NewObjectiveBillboard.MarkerObject = MarkerObject;
    }
    //return;    
}

function RemoveTeamObjectiveBillboard(FoxTeamObjectiveMarker MarkerObject)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xE4 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xD6
        if((FoxBillboardUITeamObjective(Billboards[I]) != none) && FoxBillboardUITeamObjective(Billboards[I]).MarkerObject == MarkerObject)
        {
            FoxBillboardUITeamObjective(Billboards[I]).MarkerObject = none;
            RemoveBillboard(Billboards[I]);
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function SpawnVehicleBillboard(FoxVehicle VehicleObject)
{
    local FoxBillboardUIVehicleMarker NewVehicleBillboard;
    local int I;
    local bool ShowScorpIcon;

    // End:0x11
    if(VehicleObject == none)
    {
        return;
    }
    I = 0;
    J0x1C:
    // End:0xA7 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x99
        if((FoxBillboardUIVehicleMarker(Billboards[I]) != none) && FoxBillboardUIVehicleMarker(Billboards[I]).VehicleObject == VehicleObject)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x1C;
    }
    NewVehicleBillboard = FoxBillboardUIVehicleMarker(SpawnBillboard(class'FoxBillboardUIVehicleMarker'));
    // End:0x1E8
    if(NewVehicleBillboard != none)
    {
        NewVehicleBillboard.VehicleObject = VehicleObject;
        // End:0x1A5
        if(FoxPawn_ScorpionTank(VehicleObject) != none)
        {
            ShowScorpIcon = true;
            NewVehicleBillboard.DefaultMoverName = class'FoxHUDUI_PL'.default.PayloadName;
            NewVehicleBillboard.SetMoverName(NewVehicleBillboard.DefaultMoverName);
        }
        // End:0x1B1
        else
        {
            ShowScorpIcon = false;
        }
        NewVehicleBillboard.SetBool("showScorpion", ShowScorpIcon);
    }
    //return;    
}

function RemoveVehicleBillboard(FoxVehicle VehicleObject)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xE4 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0xD6
        if((FoxBillboardUIVehicleMarker(Billboards[I]) != none) && FoxBillboardUIVehicleMarker(Billboards[I]).VehicleObject == VehicleObject)
        {
            FoxBillboardUIVehicleMarker(Billboards[I]).VehicleObject = none;
            RemoveBillboard(Billboards[I]);
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function SpawnAmmoPackBillboard(FoxProjectile_AmmoPackBase AmmoPack)
{
    local FoxBillboardUIAmmoPack NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIAmmoPack(Billboards[I]) != none) && FoxBillboardUIAmmoPack(Billboards[I]).AmmoPack == AmmoPack)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIAmmoPack(SpawnBillboard(class'FoxBillboardUIAmmoPack'));
    NewBillboard.AmmoPack = AmmoPack;
    //return;    
}

function RemoveAmmoPackBillboard(FoxProjectile_AmmoPackBase AmmoPack)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIAmmoPack(Billboards[I]) != none) && FoxBillboardUIAmmoPack(Billboards[I]).AmmoPack == AmmoPack)
        {
            FoxBillboardUIAmmoPack(Billboards[I]).AmmoPack = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnPickupBillboard(FoxDroppedPickup_UIMesh inPickup)
{
    local FoxBillboardUIPickupBase NewBillboard;
    local class<FoxBillboardUIPickupBase> BillboardClass;
    local int I;

    BillboardClass = inPickup.BillboardClass;
    // End:0x11B
    if(BillboardClass != none)
    {
        I = 0;
        J0x42:
        // End:0xCD [Loop If]
        if(I < Billboards.Length)
        {
            // End:0xBF
            if((FoxBillboardUIPickupBase(Billboards[I]) != none) && FoxBillboardUIPickupBase(Billboards[I]).Pickup == inPickup)
            {
                return;
            }
            ++ I;
            // [Loop Continue]
            goto J0x42;
        }
        NewBillboard = FoxBillboardUIPickupBase(SpawnBillboard(BillboardClass));
        NewBillboard.Pickup = inPickup;
    }
    //return;    
}

function PickupPickedUp(FoxDroppedPickup_UIMesh inPickup, bool bPickedUpByLocalPlayer)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0x129 [Loop If]
    if(I >= 0)
    {
        // End:0x11B
        if((FoxBillboardUIPickupBase(Billboards[I]) != none) && FoxBillboardUIPickupBase(Billboards[I]).Pickup == inPickup)
        {
            // End:0xE6
            if(bPickedUpByLocalPlayer || FoxBillboardUICoinToken(Billboards[I]) != none)
            {
                Billboards[I].DockBillboard();
            }
            // End:0x118
            else
            {
                FoxBillboardUIPickupBase(Billboards[I]).as_PlayDeathAnimation();
            }
            // [Explicit Break]
            goto J0x129;
        }
        -- I;
        J0x129:
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function RemovePickupBillboard(FoxDroppedPickup_UIMesh inPickup)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIPickupBase(Billboards[I]) != none) && FoxBillboardUIPickupBase(Billboards[I]).Pickup == inPickup)
        {
            FoxBillboardUIPickupBase(Billboards[I]).Pickup = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnBleedOutBillboard(FoxPawn inPawn)
{
    local FoxBillboardUIBleedOutPawn NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIBleedOutPawn(Billboards[I]) != none) && FoxBillboardUIBleedOutPawn(Billboards[I]).Pawn == inPawn)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIBleedOutPawn(SpawnBillboard(class'FoxBillboardUIBleedOutPawn'));
    NewBillboard.Pawn = inPawn;
    //return;    
}

function RemoveBleedOutBillboard(FoxPawn inPawn)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIBleedOutPawn(Billboards[I]) != none) && FoxBillboardUIBleedOutPawn(Billboards[I]).Pawn == inPawn)
        {
            FoxBillboardUIBleedOutPawn(Billboards[I]).Pawn = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnBombBillboard(FoxGameObject_Bomb Bomb)
{
    local FoxBillboardUIBomb NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIBomb(Billboards[I]) != none) && FoxBillboardUIBomb(Billboards[I]).BombObject == Bomb)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIBomb(SpawnBillboard(class'FoxBillboardUIBomb'));
    NewBillboard.BombObject = Bomb;
    //return;    
}

function RemoveBombBillboard(FoxGameObject_Bomb Bomb)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIBomb(Billboards[I]) != none) && FoxBillboardUIBomb(Billboards[I]).BombObject == Bomb)
        {
            FoxBillboardUIBomb(Billboards[I]).BombObject = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}

function SpawnBombTargetBillboard(FoxGameObject_BombTarget BombTarget)
{
    local FoxBillboardUIBombTarget NewBillboard;
    local int I;

    I = 0;
    J0x0B:
    // End:0x96 [Loop If]
    if(I < Billboards.Length)
    {
        // End:0x88
        if((FoxBillboardUIBombTarget(Billboards[I]) != none) && FoxBillboardUIBombTarget(Billboards[I]).BombTarget == BombTarget)
        {
            return;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    NewBillboard = FoxBillboardUIBombTarget(SpawnBillboard(class'FoxBillboardUIBombTarget'));
    NewBillboard.BombTarget = BombTarget;
    //return;    
}

function RemoveBombTargetBillboard(FoxGameObject_BombTarget BombTarget)
{
    local int I;

    I = Billboards.Length - 1;
    J0x17:
    // End:0xE7 [Loop If]
    if(I >= 0)
    {
        // End:0xD9
        if((FoxBillboardUIBombTarget(Billboards[I]) != none) && FoxBillboardUIBombTarget(Billboards[I]).BombTarget == BombTarget)
        {
            FoxBillboardUIBombTarget(Billboards[I]).BombTarget = none;
            RemoveBillboard(Billboards[I]);
        }
        -- I;
        // [Loop Continue]
        goto J0x17;
    }
    //return;    
}
